﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub LoadINI
	Dim Map1 As Map

	If File.Exists(Starter.SharedFolder,Main.inifile) Then
		Map1 = File.ReadMap(Starter.SharedFolder,Main.inifile)

		Main.Photolab.userName = Map1.Get("UserName")
		Main.Photolab.userPassword = Map1.Get("UserPassword")
		Main.Photolab.Labs = Map1.Get("Labs")
		Main.Photolab.FirstName = Map1.Get("FirstName")
		Main.Photolab.LastName = Map1.Get("LastName")
	Else
		Main.Photolab.userName = ""
		Main.Photolab.userPassword = ""
		Main.Photolab.Labs = ""
		Main.Photolab.FirstName = ""
		Main.Photolab.LastName = ""
	End If
	
End Sub

Sub SaveINI
	Dim Map1 As Map
		Map1.Initialize
		Map1.Put("UserName", Main.Photolab.userName )
		Map1.Put("UserPassword", Main.Photolab.userPassword )
		Map1.Put("Labs", Main.Photolab.Labs )
		Map1.Put("FirstName", Main.Photolab.FirstName )
		Map1.Put("LastName", Main.Photolab.LastName )
		File.Writemap(Starter.SharedFolder, Main.inifile, Map1)
End Sub


Sub ToMixCase(Entry As String) As String

    Dim sb As StringBuilder
    Dim m As Matcher
    Dim I As Int
            
    Entry = Entry.ToLowerCase

    sb.Initialize
    
  	m = Regex.Matcher("(^\w)|([\s\']\w)", Entry)
    
    Do While m.Find
            
       If m.Match.Length > 1 Then    
    
          sb.Append(Entry.SubString2(I, m.GetStart(0) + 1))
          sb.Append(m.Match.SubString(1).ToUpperCase)
                              
       Else
      
          sb.Append(Entry.SubString2(I, m.GetStart(0)))
          sb.Append(m.Match.ToUpperCase)
                              
       End If
                     
       I = m.GetEnd(0)
                     
    Loop
            
    If I < Entry.Length Then
            
       sb.Append(Entry.SubString(I))
                     
    End If
            
    Return sb.ToString

End Sub





Sub chkUser(cUser As String, cPassword As String)
Dim  UserWs As Map
Log("user : " & cUser)
Log("Password : " & cPassword)

Try
	If (cUser<> "" Or cUser.ToLowerCase<> "null") And ( cPassword<> "" Or cPassword.ToLowerCase <>  "null") Then

		UserWs.Initialize
		UserWs.put("username",cUser)
		UserWs.put("Password",cPassword)

		InvokeWS2(Main.WS_Url,Main.WS_chk_login,"checkuser",UserWs,"B4XMainPage",10000,"Vérification...")

	End If
Catch
		'ToastMessageShow(LastException.Message, True)
	Log(LastException)
End Try	

End Sub


Sub InvokeWS2(cUrl As String, WsName As String, Jobname As String, ParamValue As Map, DoneAct As String,timeout As Int, message As String  )
Dim jobtest As HttpJob
Dim endPoint As String 
Dim requestSoapXML As String
Dim i As Int
ProgressDialogShow(message)
Dim Key, Value As String
'Sleep(100)
	
	endPoint = cUrl
	
    requestSoapXML = _
		"<soap:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap='http://schemas.xmlsoap.org/soap/envelope/'>" & _
		"<soap:Body>" & _ 
		"<" & WsName & " xmlns='http://patrick.imbault.org/'>" & CRLF
		For i = 0 To ParamValue.Size - 1
			Key = ParamValue.GetKeyAt(i)
			Value = ParamValue.GetValueAt(i)
			requestSoapXML = requestSoapXML & "<" & Key & ">" & Value & "</" & Key & ">" & CRLF
		Next
		requestSoapXML = requestSoapXML & "</" & WsName & ">" & _
		"</soap:Body>" & _
		"</soap:Envelope>"

    Log(requestSoapXML )
	
	'File.WriteString(File.DirRootExternal,"pi.txt",requestSoapXML)
	'send_ws_body(requestSoapXML )
	
	jobtest.Initialize(Jobname, DoneAct)
	jobtest.Initialize(Jobname, DoneAct)
	jobtest.PostString (endPoint, requestSoapXML)
	jobtest.GetRequest.SetContentType("")
	jobtest.GetRequest.SetHeader("SOAPAction", "http://patrick.imbault.org/"  & WsName)
	jobtest.GetRequest.SetHeader("Content-Type", "text/xml; charset=utf-8")
	jobtest.GetRequest.timeout = timeout
	
	

End Sub







Sub InvokeWS(cUrl As String, WsName As String, Jobname As String, ParamValue As Map, DoneAct As String,timeout As Int, message As String  )
Dim jobtest As HttpJob
Dim endPoint As String 
Dim requestSoapXML As String
Dim i As Int
ProgressDialogShow(message)
Dim Key, Value As String
'Sleep(100)
	
	endPoint = cUrl
	
requestSoapXML = $"<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pat="http://patrick.imbault.org/">
				<soapenv:Header/>
		   		<soapenv:Body> 
        		<pat:${WsName}>"$
		For i = 0 To ParamValue.Size - 1
			Key = ParamValue.GetKeyAt(i)
			Value = ParamValue.GetValueAt(i)
			requestSoapXML = requestSoapXML & CRLF & "<pat:" & Key & ">" & Value & "</pat:" & Key & ">" & CRLF
		Next
		requestSoapXML = requestSoapXML & "</pat:" & WsName & ">" & _
		"</soapenv:Body>" & _
		"</soapenv:Envelope>"

    Log(requestSoapXML )
	
	'File.WriteString(File.DirRootExternal,"pi.txt",requestSoapXML)
	'send_ws_body(requestSoapXML )
	
	jobtest.Initialize(Jobname, DoneAct)
	jobtest.PostString (endPoint, requestSoapXML)
	jobtest.GetRequest.SetContentType("")
	jobtest.GetRequest.SetHeader("SOAPAction", "http://patrick.imbault.org/"  & WsName)
	jobtest.GetRequest.SetHeader("Content-Type", "text/xml; charset=utf-8")
	jobtest.GetRequest.timeout = timeout
	
	

End Sub


Sub GetWsresult(job1 As HttpJob, WsName As String,jobname As String) As String
Dim i,i2 As Int
Dim sRet=-1 As String
Dim cSearch As String
Dim resultSoapXML As String
		If job1.Success = True Then
			cSearch= WsName & "Result" 
			resultSoapXML = job1.GetString
			Log(resultSoapXML)
		   	i = resultSoapXML.IndexOf("<" & cSearch & ">")    
			If i = -1 Then        
				ToastMessageShow("Invalid response.", True)        
				Return(-1) 
			End If    
			i2 = resultSoapXML.IndexOf2("</" & cSearch & ">", i + 3)    
			sRet = resultSoapXML.substring2(i + cSearch.Length + 2, i2)
		Else
			Log("Error: " & job1.ErrorMessage)
			ToastMessageShow("Error: " & job1.ErrorMessage, True)

		End If
Return sRet
End Sub 